Require Export ZArith.
Require Export List.
Require Export Arith.


Inductive dias: Set := Seg: dias | Ter:dias | Qua:dias |
           Qui: dias | Sex: dias | Sab: dias | Dom: dias.

Check dias_ind.

Reset dias.

Inductive dias: Set := Seg | Ter | Qua |
           Qui | Sex | Sab | Dom.

Check dias_ind.


Theorem dias_equal:
forall m:dias, m=Seg \/  m=Ter \/ m=Qua  \/ m=Qui
    \/ m=Sex \/ m=Sab \/ m=Dom.
Proof.
(*induction m; auto 7.*)
intro m; pattern m.
apply dias_ind.
left. reflexivity.
right. left. reflexivity.
right. right. left . reflexivity.
right. right. right. left. reflexivity.
right. right. right. right. left. reflexivity.
right. right. right. right. right. left. reflexivity.
right. right. right. right. right. right. reflexivity.
Qed.



Theorem dias_dif: forall d d1 :dias,  d=d1 \/ d <> d1.
Proof.
intros.
case d; case d1;((left; reflexivity) || (right; discriminate)).
Qed.

Check bool.
Check bool_ind.



Theorem bool_equal: forall b: bool, b=true \/ b=false.
Proof.
intros.
elim b.
left. reflexivity.
right. reflexivity.

Qed.

Definition week_end (d: dias ) : bool :=
match d with
  Sab => true |
  Dom => true |
  other  => false
end.
 

Check week_end Seg.

Eval compute in week_end Seg. 


Inductive plane: Set := point : Z -> Z -> plane.

Definition abscissa (p:plane) : Z :=
  match p with point x y => x end.

Record plane1: Set := point1 { abs: Z; ord:Z}.


(* numero de lugares e ou rodas *)
Inductive vehicle : Set :=
  | bicycle : nat -> vehicle 
  | motorized : nat -> nat -> vehicle.


Check vehicle_ind.

Definition nb_wheels (v:vehicle) : nat :=
  match v  return nat with
  | bicycle x => 2
  | motorized x n => n
  end.

Eval compute in nb_wheels (motorized 2 4).

(* Using injection *)

Theorem bicycle_eq_seats :
 forall x1 y1:nat, bicycle x1 = bicycle y1 -> x1 = y1.
Proof.
 intros x1 y1 H.
 injection H.
intros. assumption.
 (* trivial. *)
Qed.


(* inductive types *) 
Theorem zz: 0<= 0.
Proof.
Print le.
constructor 1.
Qed.


Theorem ut: 1<= 3.
Proof.
repeat constructor.
constructor 2.
constructor 2.
constructor 1.
Qed.
