
Definition my_n: forall n: nat, n<= n.
Proof.
induction n.
2:trivial.
trivial.
Qed.

Check le_n.
Check le_S.

Check (le_n 36).

Check (le_S 36 36).

Check (le_S 36 36 (le_n 36)).


Theorem leii: forall i:nat, i<= S ( S i).
Proof.
intros.
apply le_S.
apply le_S.
apply le_n.
Qed.

Print leii.

Check leii.

Definition compose : forall A B C : Set, (A->B)->(B->C)->A->C
   := fun A B C f g x => g (f x).

Print compose.

Theorem imp_trans: forall P Q R : Prop, (P->Q) -> (Q->R) -> P ->R.
Proof.
intros P Q R H H0 p.
apply H0. apply H. assumption.
Qed. 
Print imp_trans.


Check (imp_trans _ _ _ (le_S 0 1) (le_S 0 2)).


(* fol polimorfic *)
Theorem all_imp_dist: forall (A:Type)(P Q:A->Prop),
(forall x:A, P x -> Q x) -> (forall y:A, P y) -> (forall z:A, Q z).
Proof.
intros A P Q H H0 z.
apply H.
apply H0. 

Qed.
Print all_imp_dist.



Theorem all_perm: forall (A:Type) (P: A-> A-> Prop), (forall x y: A, P
  x y) -> forall x y:A, P y x.
Proof.
intros A P H z w. Show Proof.
apply H.
Qed.
Print all_perm.

Theorem resolution: forall (A:Type) (P Q R S: A-> Prop),
(forall a:A, Q a -> R a -> S a) -> (forall b: A , P b -> Q b)
-> (forall c: A , P c -> R c -> S c).
Proof.
intros A P Q R S H H0 c H1 H2.
apply H.
apply H0.


Show 1.


exact H1.
exact H2.
Qed.

Print resolution.


(* logic connectives *)

Print and.
Check conj.
Check and_ind.




Theorem conj3 : forall P Q R:Prop, P->Q-> R-> P/\(Q/\R).
Proof.
intros A B C H H1 H2.
apply conj.
assumption.
apply conj.
assumption.
assumption.
Qed.

Print conj3.


Theorem conj31 : forall P Q R:Prop, P->Q-> R-> P/\Q/\R.
Proof.
intros A B C H H1 H2.
split.
assumption.
split.
assumption.
assumption.
Qed.

Print conj31.

Theorem conj3' : forall P Q R:Prop, P->Q-> R-> P/\Q/\R.
Proof (fun P Q R p q r => conj p( conj q r)).

Theorem and_c1: forall A B: Prop, (A/\ B) -> (B /\ A).
Proof.
intros X Y H.
apply and_ind with 
(A:=X) (B:=Y).
(* (A:=A) (B:=B). *)
intros. apply conj. assumption. assumption. assumption.
Qed.

Theorem and_c: forall A B: Prop, (A/\ B) -> (B /\ A).
Proof.
intros A B H.
elim H.
split.
assumption.
assumption.
Qed.

(* or *)
Print or.
Check or_introl.
Check or_intror.
Check or_ind.

Theorem or_com: forall A B: Prop, A\/ B -> B\/A.
Proof.
intros A B H. 
apply or_ind with (A:= A) (B:= B).
intro ha.
right.
assumption.
intro ha.
left.
assumption.
assumption.
Qed.

Theorem disj3: forall P Q R S: Prop, R-> P\/Q \/ R\/S.
Proof.
right.
right.
left.
assumption.
Qed.
Print disj3.



Check or_com.
Print or_com.
Check or_ind.





Check False.

Print False.
Check False_ind.

Section ex_falso.
Hypothesis ff: False.

Lemma exq: 220=284.
Proof.
apply False_ind.
exact ff.
Qed.
Print exq.
End ex_falso.

Lemma exq1: False -> 220=284.
Proof.
apply False_ind.
Qed.

Print exq.

Print exq1.

Theorem absurd: forall P Q :Prop, P -> ~P -> Q.
Proof.
intros P Q  p H.
Check H.
apply False_ind.
elim H.
assumption.
Qed.
Print absurd.


(* Lemma ex2: 220=284. *)
(* Proof. *)
(* Hypothesis fff:False. *)
(* elim fff. *)
(* Qed. *)
(* Print ex2. *)

Theorem double_neg: forall P:Prop, P -> ~~P.
Proof.
intros P p.
intro H.
apply H.
(* elim H. *)
assumption.
Qed.

Print double_neg.
Print False_ind.
Print False.



Theorem modus_ponens: forall P Q:Prop, P->(P->Q)->Q.
Proof.
intros P Q p H.
apply H.
assumption.

Qed.
Print modus_ponens.

Theorem double_nneg: forall P:Prop, P -> ~~P.
Proof (fun P => modus_ponens P False).

Theorem Contraposition : forall A B:Prop,(A->B) -> ~B-> ~A.
Proof.
intros A B.

Print not.
unfold not.
apply imp_trans.
Qed.

(* exists *)
Check ex.
Print ex.

Check ex_intro.
Check ex_ind.

Lemma ex_imp_ex :
 forall (A:Type)(P Q:A->Prop), (ex P)->
          (forall x:A, P x -> Q x)->(ex Q).
Proof.
 intros A P Q H H0.
 elim H.
 intros a Ha.
 exists a.
 apply H0; exact Ha.
Qed.

Lemma ex_or:  forall (A:Type)(P Q:A->Prop), 
       (exists x:A, P x \/ Q x) -> (ex P)\/ (ex Q).
Proof.
intros.
elim H.
intros.
elim H0.
intros.
left.
exists x.
assumption.
intros.
right.
exists x.
assumption.
Qed.


(* equality *)

Check eq.
Print eq.
Print eq_ind.

Lemma L36 : 6*6=9*4.
Proof.
 reflexivity.
Qed.

Lemma L1: forall (f: nat -> nat) (k:nat), f 0 = 0 -> k=0 -> f k =k.
Proof.
intros.
rewrite H0.
assumption.
Qed.


Theorem eq_sym' : forall (A:Type)(a b:A), a=b->b=a.
Proof.
 intros A a b e.
 rewrite e.
 reflexivity.
Qed.


Check refl_equal.

Theorem orequal: forall (A:Type) (a b c d: A), a=c \/ b=c \/ c=c \/ d=c.
Proof.
intros.
right. right. left.  reflexivity.
Qed.

Section Ref.
Variable D: Set.
Variable R: D-> D-> Prop.
Hypothesis Anti_sym : forall x y: D, R x y -> ~ R y x.

Theorem not_ref:forall x:D,  ~ R x x.
Proof.
intro x.
intro.
apply (Anti_sym x x).
assumption.
assumption.
Qed.

Print not_ref.
End Ref.

Require  Export  ZArith.
Open Scope Z_scope.

Theorem Zmult_distr_1: forall n x:Z, n*x +x= (n+1)*x.
Proof.
intros.
Check Z.mul_add_distr_r. 
rewrite Z.mul_add_distr_r.
rewrite  Z.mul_1_l.
reflexivity.
Qed.


Theorem  cinco:  forall x:Z, x+x+x+x+x= 5*x.
Proof.
intro x.
pattern x at 1.
rewrite <- Z.mul_1_l.
repeat rewrite Zmult_distr_1.
ring.
Qed.

