Require Export ZArith.

Print nat.
Check nat_ind.
Print nat_ind.

Print plus.
Print Nat.add.
Check Nat.add.
Print plus_O_n.
Check plus_O_n.
Check plus_Sn_m.

Theorem plus_assoc:
forall x y z: nat, (x+y)+z=x+(y+z).
Proof.
intros X Y Z.
elim X.
rewrite plus_O_n.
rewrite plus_O_n.
reflexivity.
intros n H.
rewrite (plus_Sn_m n Y).
rewrite (plus_Sn_m (n + Y) Z).
rewrite (plus_Sn_m). rewrite H.
reflexivity.
Qed.

Theorem plus_assoc2 :
 forall x y z:nat, (x+y)+z = x+(y+z).
Proof.
 intros x y z.
 elim x.
 rewrite plus_O_n.
 rewrite plus_O_n. 
 reflexivity. 
 intros x' Hrec.
rewrite plus_Sn_m.
rewrite plus_Sn_m.
rewrite plus_Sn_m.
rewrite Hrec.
reflexivity.
(* rewrite (plus_Sn_m x' y).
 rewrite (plus_Sn_m (x'+y) z).
 rewrite plus_Sn_m; rewrite Hrec; trivial.*)
Qed.


Fixpoint mult2 (n:nat) : nat := 
match n with 
0 => 0
| S  p =>  S ( S (mult2 p))
end.

Print mult2.

Eval compute in (mult2 (S 0)).

Eval compute in (mult2 (S ( S 0))).



Theorem plus_assoc':
forall x y z: nat, (x+y)+z=x+(y+z).
Proof.
intros X Y Z.
elim X.
simpl.
reflexivity.
simpl.
intros n H.
rewrite H.
reflexivity.
Qed.

Theorem plus_n_O': forall n:nat,n=n+0.
Proof.
intro H.
elim H.
simpl.
trivial.
simpl.
intros n H'.
rewrite <- H'.
reflexivity.
Qed.

Print plus_n_O'.

Lemma le_0_n: forall n: nat, n<=0 -> n=0.
Proof.
intros.
induction n.
reflexivity.
inversion H.
Qed.

Definition mult2' : nat->nat :=
  fix f (n:nat) : nat :=
    match n with 0 => 0 | S p => S (S (f p)) end.



Definition pred_option (n:nat) : option nat :=
  match n with O => None | S p => Some p end.

Definition pred2_option (n:nat) : option nat :=
  match pred_option n with
  | None => None
  | Some p => pred_option p
  end.

Check (sum nat bool). 

Check (inl bool 4).

Check (inr nat false).